import 'package:apex_flutter_plugin/api/request.dart';
import 'package:apex_flutter_plugin/server.dart';

class UserVerificationRequest extends Request {
  final int countryCode;
  final String username;

  UserVerificationRequest(this.countryCode, this.username)
      : super({'cc': countryCode, 'username': username},
            isPrivate: true, action: 1001);
}

class UserVerificationAction extends BaseAction {
  UserVerificationAction(int success, String message) : super(success, message);

  factory UserVerificationAction.fromJson(Map<String, dynamic> json) {
    return UserVerificationAction(json['success'], json['message'] ?? '');
  }
}
